/*
Data una sequenza di byte che rappresenta l'intestazione di una trama 802.11, decodificarne il tipo.
(+ il primo CTS del pacchetto wpa_Induction.pcap
0000  00 00 18 00 8e 58 00 00  10 16 6c 09 a0 00 58 00   .....X.. ..l...X.
0010  00 28 00 00 55 09 cb 58  c4 00 68 00 00 0c 41 82   .(..U..X ..h...A.
0020  b2 55 55 09 cb 58                                  .UU..X
*/

#include <stdio.h>
#include <string.h>

#define TYPEMASK    (0x0c)  //0ch = 00001100b
#define TYPE_MNGMT  (0x00)  //00h = 00000000b
#define TYPE_CTRL   (0x04)  //04h = 00000100b

#define SUBTYPEMASK (0xf0)  //f0h = 11110000b
#define SUBTYPE_RTS (0xb0)  //b0h = 10110000b
#define SUBTYPE_CTS (0xc0)  //c0h = 11000000b
#define SUBTYPE_ACK (0xd0)  //d0h = 11010000b

char* DectoszBin(int quale, int contenitore, char* szbinary);

int main (void)
{
  unsigned char aFrame[14]={0xc4,0x00,0x68,0x00,0x00,0x0c,0x41,0x82,0xb2,0x55,0x55,0x09,0xcb,0x58};
  char szMsg[80], szBinary[17];
  int i;

  printf("Frame 802.11: ");
  for (i=0;i<16;i++) printf("%02x ",aFrame[i]);

  strcpy(szMsg,"TYPE ");
  if ((TYPEMASK & aFrame[0]) == TYPE_CTRL)
  {
    strcat(szMsg,"control; SUBTYPE ");
    if ((SUBTYPEMASK & aFrame[0]) == SUBTYPE_ACK)
      strcat(szMsg,"ACK");
    else
    {
      if ((SUBTYPEMASK & aFrame[0]) == SUBTYPE_CTS) strcat(szMsg,"CTS");
      else strcat(szMsg,"RTS");
    }
  }
  else
    strcat(szMsg,"management");

  printf("\nFrame control=%02x%02xh (%s): %s",aFrame[0],aFrame[1], DectoszBin(aFrame[0]*0x100+aFrame[1],16,szBinary), szMsg);

  return 0;
}

char* DectoszBin(int quale, int contenitore, char* szbinary)
{
  unsigned int mask;
  int i;

  mask = 0;
  mask = 1 << (contenitore-1);

  i = 0;
  while(mask)
  {
    if (quale & mask) szbinary[i] = '1'; else szbinary[i] = '0';
    mask = mask >> 1;
    i++;
  }
  szbinary[i] = 0;
  return szbinary;
}

